require("dotenv").config();
const nodemailer = require("nodemailer");
const { google } = require("googleapis");
const { OAuth2 } = google.auth;
const { getMonashId, getUserProfile } = require("../firebase/firebaseHelper");

const OAUTH_PLAYGROUND = "https://developers.google.com/oauthplayground";
const {
  MAILING_SERVICE_CLIENT_ID,
  MAILING_SERVICE_CLIENT_SECRET,
  MAILING_SERVICE_REFRESH_TOKEN,
  SENDER_EMAIL_ADDRESS,
} = process.env;

const oauth2Client = new OAuth2(
  MAILING_SERVICE_CLIENT_ID,
  MAILING_SERVICE_CLIENT_SECRET,
  OAUTH_PLAYGROUND
);

async function sendEmail(userId, channel, message) {
  const { id, role } = await getMonashId(channel, userId);
  const { name, email } = await getUserProfile(id, role);

  try {
    oauth2Client.setCredentials({
      refresh_token: MAILING_SERVICE_REFRESH_TOKEN,
    });
    const accessToken = oauth2Client.getAccessToken();

    const transporter = nodemailer.createTransport({
      service: "gmail",
      auth: {
        type: "OAuth2",
        user: SENDER_EMAIL_ADDRESS,
        clientId: MAILING_SERVICE_CLIENT_ID,
        clientSecret: MAILING_SERVICE_CLIENT_SECRET,
        refreshToken: MAILING_SERVICE_REFRESH_TOKEN,
        accessToken,
      },
    });

    const date = new Date();
    const utc = Date.UTC(
      date.getUTCFullYear(),
      date.getUTCMonth(),
      date.getUTCDate(),
      date.getUTCHours(),
      date.getUTCMinutes(),
      date.getUTCSeconds()
    );
    const timestamp = new Date(utc);
    const welcome = `<p>Hi ${name},</p>`;
    const comment = `<p>${message}</p><br/>`;
    const botIcon = `<p style="color:#616161">--------------------<br/><br/><img src="https://firebasestorage.googleapis.com/v0/b/wechaty-demo.appspot.com/o/Images%2FBotIcon.png?alt=media&token=f5b32c07-e502-487e-b020-0fcf5aa793eb" style="max-width:150px"/>`;
    const contact = `<p style="color:#616161"><b>Peer Assessment Bot</b><br/><br/>Monash University<br/>Faculty of Information Technology<br/>FIT4005/5125/5143 Research Methods in IT<br/>Semester 1, 2020</p>`;
    const autoReply = `<p style="color:#bcbcbc">This message was automatically generated by Peer Assessment Bot on ${timestamp}. Replies are not monitored or answered.</p>`;

    let mailOptions = {
      from: SENDER_EMAIL_ADDRESS,
      to: email,
      subject:
        "Peer Assessment Notification - New Detailed Comment Received 📝",
      html: welcome + comment + botIcon + contact + autoReply,
    };

    transporter.sendMail(mailOptions, function (error, info) {
      if (error) {
        console.log(error);
      } else {
        console.log("Email Sent: " + info.response);
      }
    });
  } catch (error) {
    console.error(error);
  }
}

exports.sendEmail = sendEmail;
